package com.yxf.clippathlayout.sample;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;

import com.yxf.clippathlayout.pathgenerator.AnimTransition;
import com.yxf.clippathlayout.transition.TransitionAdapter;
import com.yxf.clippathlayout.transition.TransitionFrameLayout;
import com.yxf.clippathlayout.transition.generator.RandomTransitionPathGenerator;

public class TransitionActivity extends AppCompatActivity {

    TransitionFrameLayout mLayout;
    View mRedView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_transition);
        Intent intent = this.getIntent();
        ImageView iv = findViewById(R.id.iv);
        byte[] byteTemp = intent.getByteArrayExtra("bitmap");
        Bitmap bitmap = BitmapFactory.decodeByteArray(byteTemp, 0, byteTemp.length);
        iv.setImageBitmap(bitmap);
        mLayout = findViewById(R.id.transition_layout);
        RandomTransitionPathGenerator generator =
                new RandomTransitionPathGenerator(new AnimTransition());
        mLayout.setAdapter(new TransitionAdapter(generator));
        mRedView = findViewById(R.id.red_view);
        TransitionAdapter adapter = mLayout.switchView(mRedView);
        adapter.animate();
    }
}