package com.yxf.clippathlayout.pathgenerator;

import android.graphics.Path;
import android.graphics.Rect;
import android.util.Log;
import android.view.View;

import com.yxf.clippathlayout.transition.generator.TransitionPathGenerator;

public class AnimTransition implements TransitionPathGenerator {
    private final static String TAG = "AnimTransition";

    @Override
    public Path generatePath(Path old, View view, int width, int height) {
        if (old == null) {
            old = new Path();
        } else {
            old.reset();
        }
        int radius = Math.min(width, height) / 2;

        float degA, degB;
        if (5 % 2 == 1) {//奇数和偶数角区别对待
            degA = 360 / 5 / 2 / 2;
            degB = 180 - degA - 360 / 5 / 2;
        } else {
            degA = 360 / 5 / 2;
            degB = 180 - degA - 360 / 5 / 2;
        }
        float r = (float) (radius * Math.sin(rad(degA)) / Math.sin(rad(degB)));

        float perDeg = 360 / 5;
        float degAn = perDeg / 2 / 2;
        float degBn = 360 / (5 - 1) / 2 - degAn / 2 + degAn;
//        old.moveTo(
//                (float) (Math.cos(rad(degAn + perDeg * 0)) * radius + radius * Math.cos(rad(degAn))),
//                (float) (-Math.sin(rad(degAn + perDeg * 0)) * radius + radius));
//        for (int i = 0; i < 5; i++) {
//            old.lineTo(
//                    (float) (Math.cos(rad(degAn + perDeg * i)) * radius + radius * Math.cos(rad(degAn))),
//                    (float) (-Math.sin(rad(degAn + perDeg * i)) * radius + radius));
//            old.lineTo(
//                    (float) (Math.cos(rad(degBn + perDeg * i)) * r + radius * Math.cos(rad(degAn))),
//                    (float) (-Math.sin(rad(degBn + perDeg * i)) * r + radius));
//        }
//        old.close();
        Log.i(TAG, "外接圆半径:" + radius);
        Log.i(TAG, "内接圆半径:" + r);
        Log.i(TAG, "宽:" +width);
        Log.i(TAG, "高:" + height);
        Log.i(TAG, "点1：(" + (float) (Math.cos(rad(degAn + perDeg * 0)) * radius + radius * Math.cos(rad(degAn))) +
                        "," + (float) (-Math.sin(rad(degAn + perDeg * 0)) * radius + radius) + ")\n" +
                "点2：(" + (float) (Math.cos(rad(degAn + perDeg * 0)) * radius + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degAn + perDeg * 0)) * radius + radius) + ")\n" +
                "点3：(" + (float) (Math.cos(rad(degBn + perDeg * 0)) * r + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degBn + perDeg * 0)) * r + radius) + ")\n" +
                "点4：(" + (float) (Math.cos(rad(degAn + perDeg * 1)) * radius + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degAn + perDeg * 1)) * radius + radius) + ")\n" +
                "点5：(" + (float) (Math.cos(rad(degBn + perDeg * 1)) * r + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degBn + perDeg * 1)) * r + radius) + ")\n" +
                "点6：(" + (float) (Math.cos(rad(degAn + perDeg * 2)) * radius + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degAn + perDeg * 2)) * radius + radius) + ")\n" +
                "点7：(" + (float) (Math.cos(rad(degBn + perDeg * 2)) * r + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degBn + perDeg * 2)) * r + radius) + ")\n" +
                "点8：(" + (float) (Math.cos(rad(degAn + perDeg * 3)) * radius + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degAn + perDeg * 3)) * radius + radius) + ")\n" +
                "点9：(" + (float) (Math.cos(rad(degBn + perDeg * 3)) * r + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degBn + perDeg * 3)) * r + radius) + ")\n" +
                "点10：(" + (float) (Math.cos(rad(degAn + perDeg * 4)) * radius + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degAn + perDeg * 4)) * radius + radius) + ")\n" +
                "点11：(" + (float) (Math.cos(rad(degBn + perDeg * 4)) * r + radius * Math.cos(rad(degAn))) +
                "," + (float) (-Math.sin(rad(degBn + perDeg * 4)) * r + radius) + ")\n"
        );
        return regularStarPath(old, 5, radius);
    }

    /**
     * 画正n角星的路径:
     *
     * @param num 角数
     * @param R   外接圆半径
     * @return 画正n角星的路径
     */
    public static Path regularStarPath(Path old, int num, float R) {
        float degA, degB;
        if (num % 2 == 1) {//奇数和偶数角区别对待
            degA = 360 / num / 2 / 2;
            degB = 180 - degA - 360 / num / 2;
        } else {
            degA = 360 / num / 2;
            degB = 180 - degA - 360 / num / 2;
        }
        float r = (float) (R * Math.sin(rad(degA)) / Math.sin(rad(degB)));
        return nStarPath(old, num, R, r);
    }

    /**
     * n角星路径
     *
     * @param num 几角星
     * @param R   外接圆半径
     * @param r   内接圆半径
     * @return n角星路径
     */
    public static Path nStarPath(Path old, int num, float R, float r) {
        float perDeg = 360 / num;  // 72
        float degAn = perDeg / 2 / 2;  // 18
        float degBn = 360 / (num - 1) / 2 - degAn / 2 + degAn;  // 54
        old.moveTo(
                (float) (Math.cos(rad(degAn)) * R * 2 + (2 * R - Math.cos(rad(degAn)) * R * 2) / 2),
                (float) (-Math.sin(rad(degAn)) * R + R + R));
//        old.moveTo(
//                (float) (Math.cos(rad(degAn + perDeg * 0)) * R + R * Math.cos(rad(degAn))),
//                (float) (-Math.sin(rad(degAn + perDeg * 0)) * R + R + R));
        for (int i = 0; i < num; i++) {
            old.lineTo(
                    (float) (Math.cos(rad(degAn + perDeg * i)) * R + R * Math.cos(rad(degAn)) + (2 * R - Math.cos(rad(degAn)) * R * 2) / 2),
                    (float) (-Math.sin(rad(degAn + perDeg * i)) * R + R + R));
            old.lineTo(
                    (float) (Math.cos(rad(degBn + perDeg * i)) * r + R * Math.cos(rad(degAn)) + (2 * R - Math.cos(rad(degAn)) * R * 2) / 2),
                    (float) (-Math.sin(rad(degBn + perDeg * i)) * r + R + R));
        }
        old.close();
        return old;
    }
    /**
     * 角度制化为弧度制
     *
     * @param deg 角度
     * @return 弧度
     */
    public static float rad(float deg) {
        return (float) (deg * Math.PI / 180);
    }

    @Override
    public Rect maxContainSimilarRange(Rect similar, int boundWidth, int boundHeight) {

        int centerX = boundWidth / 2;
        int centerY = boundHeight / 2;
        int radius = Math.min(boundWidth, boundHeight) / 2;

        return new Rect(centerX - radius - radius,centerY - radius - radius,
                centerX + radius + radius, centerY + radius + radius);
    }
}
